# Notes on container dind in GitLab CI 
# https://about.gitlab.com/blog/2019/08/28/building-build-images/
# https://gitlab.com/snorrelo/docker_buildx_usage_example/-/blob/main/.gitlab-ci.yml

build-image:
  rules:
    - if: |
        $CI_COMMIT_BRANCH                    == $CI_DEFAULT_BRANCH ||
        $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH
      changes:
      - docker-build-context/*
      - .gitlab-ci.yml
  stage: .pre
  image: docker
  services:
    - docker:dind
  script:
    - echo $CI_REGISTRY_PASSWORD |
        docker login --password-stdin --username $CI_REGISTRY_USER $CI_REGISTRY
    - docker build -t $DOCKER_ENV_CI_REGISTRY_IMAGE:latest docker-build-context
    - docker push $CI_REGISTRY_IMAGE:latest

spellcheck:
  stage: test
  image: $CI_REGISTRY_IMAGE:latest
  script:
  - make spelling

linkcheck:
  stage: test
  image: $CI_REGISTRY_IMAGE:latest
  script:
  - make linkcheck

lint:
  stage: test
  image: $CI_REGISTRY_IMAGE:latest
  script:
  - make lint

# Example CI deployment based on https://gitlab.com/pages/sphinx
pages:
  rules:
    - if: |
        $CI_COMMIT_BRANCH                    == $CI_DEFAULT_BRANCH ||
        $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH
  stage: .post
  image: $CI_REGISTRY_IMAGE:latest
  script:
  - make html pdf
  - mv build/html/ public/
  - mv build/latex/docslikecodedemo.pdf public/
  artifacts:
    paths:
    - public

